import * as tslib_1 from "tslib";
import { ClassName, getSelectorFromElement, NAME, OcOption, Selector } from "@onoffcanvas/core";
import $ from "jquery";
var JQUERY_NO_CONFLICT = $.fn[NAME];
/** @internal */
var OnoffCanvas = /** @class */ (function () {
    function OnoffCanvas(element, config) {
        this.element = element;
        this.config = tslib_1.__assign({}, OcOption, (typeof config === "object" && config ? config : {}));
        this.triggerElements = $.makeArray(document.querySelectorAll(Selector.DATA_TOGGLE + "[href=\"#" + element.id + "\"]," +
            (Selector.DATA_TOGGLE + "[data-target=\"#" + element.id + "\"]")));
        var triggers = [].slice.call(document.querySelectorAll(Selector.DATA_TOGGLE));
        for (var i = 0, len = triggers.length; i < len; i++) {
            var elem = triggers[i];
            var selector = getSelectorFromElement(elem);
            var filterElement = [].slice
                .call(document.querySelectorAll(selector))
                .filter(function (foundElem) { return foundElem === element; });
            if (selector !== null && filterElement.length > 0) {
                this.$selector = selector;
                this.triggerElements.push(elem);
            }
        }
        this.addAriaExpanded(triggers);
        this.toggle();
    }
    OnoffCanvas.prototype.toggle = function () {
        if ($(this.element).hasClass(ClassName.SHOW)) {
            this.hide();
        }
        else {
            this.show();
        }
    };
    OnoffCanvas.prototype.show = function () {
        if ($(this.element).hasClass(ClassName.SHOW)) {
            return;
        }
        $(this.element).addClass(ClassName.SHOW);
        this.addAriaExpanded(this.triggerElements);
    };
    OnoffCanvas.prototype.hide = function () {
        if (!$(this.element).hasClass(ClassName.SHOW)) {
            return;
        }
        $(this.element).removeClass(ClassName.SHOW);
        this.addAriaExpanded(this.triggerElements);
    };
    /** @internal */
    OnoffCanvas.prototype.addAriaExpanded = function (triggerElements) {
        var isOpen = $(this.element).hasClass(ClassName.SHOW);
        $(triggerElements).attr("aria-expanded", isOpen ? "true" : "false");
    };
    // tslint:disable-next-line:member-ordering
    OnoffCanvas.JQI = function (config) {
        return this.each(function () {
            var $this = $(this);
            var data = $(this).data(NAME);
            var conf = tslib_1.__assign({}, OcOption, $this.data(), (typeof config === "object" && config ? config : {}));
            if (!data) {
                data = new OnoffCanvas(this, conf);
                $this.data(NAME, data);
            }
            if (typeof config === "string") {
                if (typeof data[config] === "undefined") {
                    throw new TypeError("No method named \"" + config + "\"");
                }
                data[config]();
            }
        });
    };
    return OnoffCanvas;
}());
$(document).on("click.onoffcanvas.data-api", Selector.DATA_TOGGLE, function (event) {
    event.preventDefault();
    var $trigger = $(this);
    var selector = getSelectorFromElement(this);
    var selectors = [].slice.call(document.querySelectorAll(selector));
    $(selectors).each(function () {
        var $target = $(this);
        var data = $target.data(NAME);
        var config = data ? "toggle" : $trigger.data();
        OnoffCanvas.JQI.call($target, config);
    });
});
$.fn[NAME] = OnoffCanvas.JQI;
$.fn[NAME].Constructor = OnoffCanvas;
$.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return OnoffCanvas.JQI;
};
/** @internal */
export default OnoffCanvas;
